mod Ex06b

incl Mtex

incl Mtexrc

incl Maux

loc rem 
  \para \bf  6. CVIČENIE Z PREDMETU 1-AIN-625 ÚVOD DO MATEMATICKEJ LOGIKY PRE 
  PROGRAMÁTOROV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Dátum:  \end utorok 23.10.2012 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-625-lpp/1213zs/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované primitívne 
  rekurzívnym funkciam (rekurzia so substitúciou v parametri, vnorená 
  jednoduchá rekurzia). Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbor(y) \it  mtex*.cl  \end obsahuje makrá pre CL-TeX. 
   \item \para Súbor(y) \it  maux*.cl  \end obsahuje definície niektorých 
         funkcií a predikátov. 
   \item \para Súbor(y) \it  ex*.cl  \end obsahuje úlohy, ktoré máte 
         riešiť na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje syntax systému CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 0 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 3 
  \end
  \para Odovzdať do 29.10.2012 (pondelok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Recursive Functions. Downloadable 
         lecture notes available through the web page of the course. 
   \item \para \it  [2]  \end J. Komara and P. J. Voda. Lecture Notes in Theory 
         of Computability. 2001. 
   \item \para \it  [3]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
   \item \para \it  [4]  \end I. Korec. Úvod do teórie algoritmov. Skriptá 
         MFF UK, 1981. 
  \end

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/2 Tex_f2_s1
  Std('s1',0)

appldisp/3 Tex_f3_s2
  Std('s2',0)

appldisp/4 Tex_f4_rec_sr_map
  Prefix(90,2,Subsup(Id(0,'M',0),75,Arg(0),None),
         Fenced(Op('(',0),
                Infix(Arg(1),30,2,Op(',',0),Infix(Arg(2),30,2,Op(',',0),Arg(3))),
                Op(')',0)))

rem 
  \para \bf  Chapter. Primitive Recursive Functions.  \end 

rem 
  \para \bf  Section. Nested Simple Recursion.  \end 

rem 
  \para \bf  Subsection. Nested Simple Recursion: Case \ft k = 2 \end and One 
  Parameter.  \end 

theory Nested_simple_recursion

fun G 'Tex_f1_g'

fun/4 H1 'Tex_f4_h'

fun/2 Sb1 'Tex_f2_s1'

fun/3 Sb2 'Tex_f3_s2'

loc rem 
  \para \bf  Exercise. \it  (bonus 3 points)  \end  \end 
  \header* fun/2 F 'Tex_f2_f' \end Show that if \ft G(y) \end, 
  \ft H1(x,z1,z2,y) \end, \ft Sb1(x,y) \end and \ft Sb2(x,y,z1) \end are all 
  primitive recursive then so is \ft F(x,y) \end defined by 

fun/2 F 'Tex_f2_f'
  F(0,y) = G(y)
  F(x+1,y) = H1(x,F(x,Sb1(x,y)),F(x,Sb2(x,y,F(x,Sb1(x,y)))),y)

loc rem 
  \para \it  Hint.  \end \header* fun/2 Cvf 'Tex_f2_rec_cvf_f' \end Derive the 
  function as primitive recursive with the help of its course of values 
  function: 

fun/2 Cvf 'Tex_f2_rec_cvf_f'
  Cvf(0,y) = F(0,y),0,0
  Cvf(x+1,y) = F(x+1,y),Cvf(x,Sb1(x,y)),Cvf(x,Sb2(x,y,F(x,Sb1(x,y))))

loc rem 
  \para \it  Proof.  \end 

loc rem 
  \para \it  Local update.  \end \header* fun/4 U  \end The 4-ary function 
  \ft U(x,y,t,i) \end updates the partial computation tree \ft t \end for 
  \ft F(x,y) \end at position \ft i \end by a correct value. Show that the 
  function is primitive recursive. 
  \para \it  [CL] Remark.  \end Clausal language allowed in the definition of 
  this function. 

fun/4 U 
  U(x,y,t,i) = Foo

loc rem 
  \para \it  Global update.  \end \header* fun/4 Map 'Tex_f4_rec_sr_map' \end 
  The 4-ary function \ft Map(i,x,y,t) \end updates the partial computation tree 
  \ft t \end for \ft F(x,y) \end at each position \ft j < i \end by a correct 
  value. Show that the function is primitive recursive. 

fun/4 Map 'Tex_f4_rec_sr_map'
  Map(i,x,y,t) = Foo

loc rem 
  \para \it  Perfect binary trees.  \end The function \ft Mkpbt(n) \end creates 
  a perfect binary tree of the depth \ft n \end. Show that the function is 
  primitive recursive. 

fun Mkpbt 
  Mkpbt(n) = Foo

loc rem 
  \para \it  Course of values function.  \end Show that the function 
  \ft Cvf(x,y) \end is primitive recursive. 

fun/2 Cvf_is_primrec 'Tex_f2_rec_cvf_f'
  Cvf_is_primrec(x,y) = Foo

loc rem 
  \para \it  Final step.  \end Show that the function \ft F(x,y) \end is 
  primitive recursive. 

fun/2 F_is_primrec 'Tex_f2_f'
  F_is_primrec(x,y) = Foo

end theory Nested_simple_recursion

rem 
  \para \bf  [CL] Remark.  \end You can test your solution by \it  interpreting 
   \end the theory. Choose \it  non-local  \end interpretation. 

rem 
  \para \bf  Subsection. Nested Simple Recursion: General Case.  \end 

rem 
  \para \bf  Theorem.  \end Primitive recursive functions are closed under 
  nested simple recursion. 

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc rem 
  \para \it  Binary Trees.  \end 

appldisp/0 Tex_f0_bt_e
  Op(Ent('bull'),0)

appldisp/3 Tex_f3_bt_nd
  Frac(Arg(0),1,Infix(Arg(1),25,3,Op(Ent('mid'),0),Arg(2)))

loc fun/0 E 'Tex_f0_bt_e'
  E = 0,0

loc fun/3 Nd 'Tex_f3_bt_nd'
  Nd(x,l,r) = 1,x,l,r

loc pred Bt 
  Bt(E)
  Bt Nd(x,l,r) <- N(x) & Bt(l) & Bt(r)

loc fun T2bt 
  T2bt(0) = E
  T2bt(z,l,r) = Nd(z,T2bt(l),T2bt(r))

loc rem 
  \para \it  Debugging.  \end 

loc rem 
  Interpretation of theory Nested_simple_recursion
  G(x1) = x1+1
  H1(x1,x2,x3,x4) = x1+x2+x3+x4
  Sb1(x1,x2) = x1+x2
  Sb2(x1,x2,x3) = x1+x2+x3

loc rem 
  Some useful queries
  0,0 = x,y & F(x,y) = z
  0,0 = x,y & Cvf(x,y) = t
  0,0 = x,y & T2bt Cvf(x,y) = t:Bt
  0,0 = x,y & Cvf_is_primrec(x,y) = t
  0,0 = x,y & T2bt Cvf_is_primrec(x,y) = t:Bt
  0,0 = x,y & F_is_primrec(x,y) = z
  data,0,0 = i,x,y & Cvf(x,y) = t1 & Map(i,x,y,Mkpbt(x+1)) = t2 & data+1 = data99
  data,0,0 = i,x,y & T2bt Cvf(x,y) = t1:Bt & T2bt Map(i,x,y,Mkpbt(x+1)) = t2:Bt & data+1 = data99

